/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#include "fsarchiver.h"

#include <stdarg.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <linux/limits.h>
#include <dirent.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "error.h"

int myprintf(int showerrno, char *format, ...)
{
	va_list ap;
	int res;
	
	if (showerrno)
		fprintf(stderr, "[errno=%d, %s]: ", errno, strerror(errno));
	va_start(ap, format);
	res = vfprintf(stderr, format, ap);
	va_end(ap);
	fflush(stderr);
	return res;
}

int logprintf(char *format, ...)
{
	va_list ap;
	int res;
	
	if (g_logfile!=NULL)	
	{
		va_start(ap, format);
		res = vfprintf(g_logfile, format, ap);
		va_end(ap);
		fflush(g_logfile);
	}
	return 0;
}
