/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#include "fsarchiver.h"

#include <string.h>
#include <stdio.h>

#include "dico.h"
#include "common.h"

int btrfs_mkfs(struct s_dico *d, char *partition, char *filesystem)
{
	char command[2048];
	
	// there is no option that just displays the version and return 0 in mkfs.btrfs-0.16
	if (exec_command(command, sizeof(command), "which mkfs.btrfs")!=0)
	{	errprintf("mkfs.btrfs not found. please install btrfs-progs on your system or check the PATH.\n");
		return -1;
	}
	
	if (exec_command(command, sizeof(command), "mkfs.btrfs %s", partition)!=0)
	{	errprintf("command [%s] failed\n", command);
		return -1;
	}

	return 0;	
}

int btrfs_get_specific_features(struct s_dico *d, char *devname)
{
	// TODO

	return 0; 
}
