/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#include "fsarchiver.h"

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <strings.h>
#include <stdarg.h>
#include <errno.h>
#include <sys/time.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <sys/stat.h>
#include <endian.h>
#include <byteswap.h>
#include <signal.h>
#include <linux/limits.h>

#include "syncthread.h"

// queue use to share data between the three sort of threads
struct s_queue g_queue;

int g_finished=false;
int g_abort=false;

int get_finished() // return true if thread must exit because everything finished successfully
{
	return g_finished==true;
}

int get_abort() // return true if a SIGINT/SIGTERM has been received or a thread failed
{
	int mysigs[]={SIGINT, SIGTERM, -1};
	sigset_t mask_set;
	sigpending(&mask_set);
	int i;
	
	if (g_abort==true) // a thread exited with an error
		return true;
	
	if (sigpending(&mask_set)==0)
	{	
		for (i=0; mysigs[i]!=-1; i++)
		{
			if (sigismember(&mask_set, mysigs[i]))
			{	dbgprintf(1, "get_terminate(): received signal %d\n", mysigs[i]);
				return true;
			}
		}
	}
	
	return false;
}

void set_finished(void)
{
	g_finished=true;
}

void set_abort(void)
{
	g_abort=true;
}
