/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __SYNCTHREAD_H__
#define __SYNCTHREAD_H__

#include "queue.h"

// global threads sync data
extern int g_finished; // all the threads must exit because of an error
extern int g_abort; // all the threads must exit because it's successfully finished
extern struct s_queue g_queue; // queue use to share data between the three sort of threads

// global threads sync functions
int get_finished(); // return true if threads must exit because everything finished successfully
int get_abort(); // returns true if threads must exit because an error or signal received
void set_finished(void); // say to other threads that everything has been finished successfully
void set_abort(void); // say to other threads that they must abort and exit

#endif // __SYNCTHREAD_H__
